#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include "puntuacion.h"
using namespace std;


Puntuacion::Puntuacion(){
	reiniciarPuntuacion();
	cargarRecords();
}

void Puntuacion::sumarAcierto(int nivel){
	if(nivel==1)
		aciertosN1++;
	if(nivel==2)
		aciertosN2++;
	if(nivel==3)
		aciertosN3++;
	if(nivel==4)
		aciertosN4++;
	if(nivel==5)
		aciertosN5++;
}

void Puntuacion::reiniciarPuntuacion(){
	aciertosN1=0;
	aciertosN2=0;
	aciertosN3=0;
	aciertosN4=0;
	aciertosN5=0;
}

int Puntuacion::getAciertos(int nivel){
	int aciertos;
	if(nivel==1)
		aciertos=aciertosN1;
	if(nivel==2)
		aciertos=aciertosN2;
	if(nivel==3)
		aciertos=aciertosN3;
	if(nivel==4)
		aciertos=aciertosN4;
	if(nivel==5)
		aciertos=aciertosN5;
	return aciertos;
}

int Puntuacion::getPuntosPNivel(int nivel){
	int puntos;
	if(nivel==1)
		puntos=puntosN1;
	if(nivel==2)
		puntos=puntosN2;
	if(nivel==3)
		puntos=puntosN3;
	if(nivel==4)
		puntos=puntosN4;
	if(nivel==5)
		puntos=puntosN5;
	return puntos;
}

int Puntuacion::getPuntos(){
	int i, aciertos, punt;
	int num=0;
	for(i=1;i<=5;i++){
		aciertos=getAciertos(i);
		punt=getPuntosPNivel(i);
		num=num+aciertos*punt;
	}
	return num;
}

double Puntuacion::getPuntosPS(int seg){
	int punt;
	double num;
	punt=getPuntos();
	num=(double)punt/seg;
	return num;
}

void Puntuacion::cargarRecords(){
	int i=0;
	string file="puntuaciones";
	string line;
	ifstream fi;
	fi.open(file.c_str(), ios::in);
	if (fi.is_open()){
		getline(fi,line);
		while (!fi.eof()){
			records[i][0]=extraerNumero(line, 1);
			records[i][1]=extraerNumero(line, 2);
			i++;
			getline(fi,line);
		}
		fi.close();
	}
}


string Puntuacion::extraerCadena(string cadena, int pos){
	int i;
	int unsigned ini=0;
	int unsigned end=0;
		for (i=0;i<=pos;i++){
			if(end!=cadena.length()){
				if(end!=0)
					ini=end+1;
				if(cadena.find('#', ini)==string::npos)
					end=cadena.length();
				else
					end=cadena.find('#', ini);
			}else
				cadena="";
		}
	if(cadena!="")
			cadena=cadena.substr(ini, end-ini);
	return(cadena);
}

int Puntuacion::extraerNumero(string cadena, int pos){
	int num;
	string texto;
	texto=extraerCadena(cadena, pos);
	num=atoi(texto.c_str());
	return num;
}

bool Puntuacion::actualizarRecords(int puntos, int tiempo, int categoria){
	bool encontrado=false;
	int i, pos;
	int fin=categoria*10-1;
	int ini=fin-9;
	if(records[fin][0]<puntos || (records[fin][0]==puntos && records[fin][1]>tiempo)){
		for(i=(fin-1);i>=ini;i--){
			if(records[i][0]<puntos){
				records[i+1][0]=records[i][0];
			}else if(records[i][0]==puntos && records[i][1]>tiempo){
				records[i+1][0]=records[i][0];
			}else if(encontrado==false){
				encontrado=true;
				pos=i;
			}
		}
		records[pos+1][0]=puntos;
		records[pos+1][1]=tiempo;
	}
	return encontrado;
}
